package cz.upol.architecture.layers.data

import android.content.Context
import androidx.room.Database
import androidx.room.Room
import androidx.room.RoomDatabase

@Database(entities = [Note::class], version = 1)
abstract class DBManager : RoomDatabase() {
    abstract fun noteDao(): NoteDao

    companion object {
        private var instance: DBManager? = null
        fun getDatabase(context: Context) : DBManager {
            if (instance != null) {
                return instance as DBManager
            } else {
                instance = Room.databaseBuilder(
                    context.applicationContext,
                    DBManager::class.java,
                    "AppDB"
                ).allowMainThreadQueries().fallbackToDestructiveMigration().build()
                return instance as DBManager
            }
        }
    }
}
