package cz.upol.architecture.layers.presentation.mainView

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import androidx.activity.viewModels
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DefaultItemAnimator
import androidx.recyclerview.widget.DividerItemDecoration
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import cz.upol.architecture.R
import cz.upol.architecture.databinding.ActivityMainBinding
import cz.upol.architecture.layers.data.Note


class MainActivity : AppCompatActivity() {
    private val model: MainActivityViewModel by viewModels { MyModelFactory() }

    private var recyclerView: RecyclerView? = null
    private var adapter: NoteAdapter? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        val binding: ActivityMainBinding = DataBindingUtil.setContentView(
            this, R.layout.activity_main
        )

        binding.model = model

        adapter = NoteAdapter(mutableListOf())
        val layoutManager = LinearLayoutManager(applicationContext)
        recyclerView = findViewById(R.id.recView)
        recyclerView?.layoutManager = layoutManager
        recyclerView?.itemAnimator = DefaultItemAnimator()
        recyclerView?.addItemDecoration(DividerItemDecoration(this, LinearLayoutManager.VERTICAL))
        recyclerView?.adapter = adapter

        model.notes.observe(this) {
            it?.let { it1 -> adapter?.setNotes(it1) }
            recyclerView?.scrollToPosition(it?.size?.minus(1) ?: 0)
        }
    }
}