package cz.upol.architecture.layers.presentation.mainView

import android.view.View
import androidx.databinding.ObservableField
import androidx.lifecycle.ViewModel
import androidx.lifecycle.ViewModelProvider
import androidx.lifecycle.viewModelScope
import cz.upol.architecture.R
import cz.upol.architecture.layers.repositories.NoteRepository
import kotlinx.coroutines.launch

class MainActivityViewModel : ViewModel() {
    val noteRepository = NoteRepository.shared()

    val notes = NoteRepository.shared().getAllNotes()
    var lastEnteredString = ObservableField<String>("Zatím nic nepřidáno")
    var added = ObservableField<Int>(R.string.add)
    var noteAddTitle = ObservableField<String>()
    var noteAddBody = ObservableField<String>()

    fun insert(title: String, text: String) {
        viewModelScope.launch {
            noteRepository.createNote(title, text,)
            added.set(R.string.addNext)
            lastEnteredString.set(title)
        }
    }

    fun saveClick(view: View) {
        insert(noteAddTitle.get()?: "", noteAddBody.get()?:"" )
        noteAddBody.set("")
        noteAddTitle.set("")
    }
}

class MyModelFactory : ViewModelProvider.Factory {
    override fun <T : ViewModel> create(modelClass: Class<T>): T {
        if (modelClass.isAssignableFrom(MainActivityViewModel::class.java)) {
            @Suppress("UNCHECKED_CAST")
            return MainActivityViewModel() as T
        }
        throw IllegalArgumentException("Unknown ViewModel class")
    }
}