package cz.upol.architecture.layers.presentation.mainView

import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import cz.upol.architecture.R
import cz.upol.architecture.layers.data.Note

class NoteAdapter(private var notes: MutableList<Note>) : RecyclerView.Adapter<NoteAdapter.NoteItemHolder> () {

    inner class NoteItemHolder(view: View) : RecyclerView.ViewHolder(view), View.OnClickListener {
        internal var title = view.findViewById<TextView>(R.id.noteTitle)
        internal var body = view.findViewById<TextView>(R.id.noteBody)

        init {
            view.isClickable = true
            view.setOnClickListener(this)
        }

        override fun onClick(p0: View?) {
            Log.w("warn", "Kliknuto na poznánmku $adapterPosition")
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): NoteItemHolder {
        val item = LayoutInflater.from(parent.context).inflate(R.layout.note_item, parent, false)
        return NoteItemHolder(item)
    }

    override fun onBindViewHolder(holder: NoteItemHolder, pos: Int) {
        val note = notes[pos]
        holder.title.text= note.title
        holder.body.text = note.text
    }

    override fun getItemCount(): Int = notes.size

    fun setNotes(notes: List<Note>) {
        this.notes.clear()
        this.notes.addAll(notes)
        notifyDataSetChanged()
    }

}