package cz.upol.architecture.layers.repositories

import androidx.lifecycle.LiveData
import cz.upol.architecture.layers.data.Note

class NoteRepository: Repository() {

    companion object {
        fun shared(): NoteRepository = NoteRepository()
    }

    suspend fun createNote(title:String, text:String) : Note {
        val note = Note(0, title,text, false)
        val newId = dbManager.noteDao().insert(note)
        return note.copy(id = newId)
    }

    fun getAllNotes() : LiveData<List<Note>> = dbManager.noteDao().getAll()

    fun deleteNote(note: Note) {
        // check oprvánění
        dbManager.noteDao().delete(note)
    }
}